#
# proj-lifespan.R, 22 Oct 12
#
# R code for book "Empirical Software Engineering using R"
# Derek M. Jones, http://shape-of-code.coding-guidelines.com
#
# Data from paper "Software Lifetime and its Evolution Process over Generations"
# by Tetsuo Tamai and Yohsuke Torimitsu


life=read.csv("/usr1/rbook/examples/economics/maint-invest/system-lifetime.csv")

par(las=1)
par(bty="l")
par(col="black")

par(mfcol=c(1,1))

num_years=nrow(life)
t=cumsum(life$projects)
num_proj=max(t)
t=num_proj-t
plot(t, ylim=c(0,num_proj), col="red", xlab="Years", ylab="Systems still in Use")

x=1:num_years
q=nls(t ~ a*b^x, start=list(a=100, b=0.8))
#q=nls(t ~ a*exp(b*x), start=list(a=100, b=0.2))
#summary(q)
par(new=TRUE)
plot(predict(q), ylim=c(0, num_proj), xlab="", ylab="")

