#
# req-cost-benefit.R, 22 Oct 12
#
# R code for book "Empirical Software Engineering using R"
# Derek M. Jones, http://shape-of-code.coding-guidelines.com

# Sum of yearly survival contributions
sur=function(c, y=6)
   return((1-c)/(c*(1-c^y)))


plot.cost.benefit=function(surviv, color, years)
{
cost.total=1+dm_ratio*sur(surviv, years)
par(new=TRUE)
plot(dm_ratio, cost.total, ylim=c(0, 8.5), col=color, type="l",
       xlab="", ylab="")
}


# Plot various project lifespans for given survival rate
cost.benefit=function(surviv, color)
{
cost.total=1+dm_ratio*sur(surviv, 5.5)
par(new=TRUE)
plot(dm_ratio, cost.total, ylim=c(0, 8.5), col=color, type="l",
       xlab="development/maintenance cost ratio",
       ylab="Break-even saving/investment ratio")
plot.cost.benefit(surviv, color, 6)
plot.cost.benefit(surviv, color, 6.5)
plot.cost.benefit(surviv, color, 7)
plot.cost.benefit(surviv, color, 7.5)
}

years=1:10
dm_ratio=seq(1, 10, by=0.5)

par(las=1)
par(bty="l")
par(col="black")

# Plot various survival rates
par(mfcol=c(1,1))
cost.benefit(0.9, "black")
cost.benefit(0.8, "red")
cost.benefit(0.7, "blue")
cost.benefit(0.6, "green")

